unit TriTile1;

{ Sample OpenGL Bitmap Render for ISO games (C)2001 by Paul TOTH <tothpaul@free.fr>
  http://tothpaul.free.fr
}
{
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
}

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  WinGL, StdCtrls, DelphiGL, GLRender, ExtDlgs;

type
  TForm1 = class(TForm)
    WinGL1: TWinGL;
    Label1: TLabel;
    WinGL2: TWinGL;
    Label2: TLabel;
    Button1: TButton;
    SavePictureDialog1: TSavePictureDialog;
    Button2: TButton;
    procedure FormCreate(Sender: TObject);
    procedure WinGL1Paint(Sender: TObject);
    procedure WinGL2Paint(Sender: TObject);
    procedure WinGL2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure WinGL2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
  private
    { Dclarations prives }
    Objet:TGLObject;
    rx,ry,rz:single;
    tz:single;
    mx,my:integer;
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
 Objet:=TGLObject.Create;
 Objet.LoadFromFile('tris.md2');//('triceratops.obj');
 Objet.Normalise;
 rx:=-90;
 tz:=-1.5;
end;

procedure TForm1.WinGL1Paint(Sender: TObject);
const
 k=2;
 d=2*k/3;
begin
 glMatrixMode(GL_PROJECTION); // changement de projection
 glLoadIdentity; // reset
 glOrtho(-k,+k, -k,+k, -1,+1);
 glMatrixMode(GL_MODELVIEW); // mode drawing
 glLoadIdentity; // reset

 Objet.Reset; // reprend le modle de base
 Objet.Rotate(rx,ry,rz);

// vue de face
 Objet.Rotate(0,-90,0);
 Objet.Render;
// marche  droite
 glTranslatef(d,0,0);
 Objet.Rotate(0,90,0);
 Objet.Rotate(45,0,0);
 Objet.Render;
// marche  gauche
 glTranslatef(-2*d,0,0);
 Objet.Rotate(0,180,0);
 Objet.Rotate(90,0,0);
 Objet.Render;
// marche en bas
 glTranslatef(d,-d,0);
 Objet.Rotate(-45,90,0);
 Objet.Rotate(45,0,0);
 Objet.Render;
// marche en haut
 glTranslatef(0,2*d,0);
 Objet.Rotate(-90,180,0);
 Objet.Render;
end;

procedure TForm1.WinGL2Paint(Sender: TObject);
begin
 glTranslatef(0,0,tz);
 Objet.Reset;
 Objet.Rotate(rx,ry,rz);
 Objet.Render;
end;

procedure TForm1.WinGL2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
 mx:=x;
 my:=y;
end;

procedure TForm1.WinGL2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
 if ssLeft in Shift then begin
  rx:=rx+(y-my);
  ry:=ry+(x-mx);
  WinGL2.Invalidate;
  WinGL1.Invalidate;
 end;
 if ssRight in Shift then begin
  rz:=rz+(x-mx);
  tz:=tz+(my-y)/100;
  WinGL2.Invalidate;
  WinGL1.Invalidate;
 end;
 mx:=x;
 my:=y;
end;

procedure TForm1.Button1Click(Sender: TObject);
var
 bmp:TBitmap;
 cnv:TCanvas;
 r:TRect;
begin
 if SavePictureDialog1.Execute then begin
  bmp:=TBitmap.Create;
  cnv:=TCanvas.Create;
  cnv.Handle:=WinGL1.DC;
  r:=WinGL1.ClientRect;
  bmp.width :=r.right-r.left;
  bmp.height:=r.bottom-r.left;
  bmp.Canvas.CopyRect(r,cnv,r);
  cnv.free;
  bmp.savetofile(SavePictureDialog1.FileName);
  bmp.free;
 end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
 rx:=-90;
 ry:=0;
 rz:=0;
 tz:=-1.5;
 WinGL1.Invalidate;
 WinGL2.Invalidate;
end;

end.
